const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const flags = sequelize.define(
    'flags',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      reason: {
        type: DataTypes.ENUM,

        values: ['COPYRIGHT', 'BRAND_ABUSE', 'MALWARE', 'OTHER'],
      },

      status: {
        type: DataTypes.ENUM,

        values: ['OPEN', 'RESOLVED', 'REJECTED'],
      },

      notes: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  flags.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.flags.belongsTo(db.profile_pages, {
      as: 'profile_page',
      foreignKey: {
        name: 'profile_pageId',
      },
      constraints: false,
    });

    db.flags.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.flags.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.flags.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return flags;
};
